<template>
    <svg class="tanuki-logo" :width="width" :height="height" viewBox="0 0 25 24" fill="none" :class="loading ? 'animate' : ''" xmlns="http://www.w3.org/2000/svg">
        <path class="tanuki-shape tanuki" d="m24.507 9.5-.034-.09L21.082.562a.896.896 0 0 0-1.694.091l-2.29 7.01H7.825L5.535.653a.898.898 0 0 0-1.694-.09L.451 9.411.416 9.5a6.297 6.297 0 0 0 2.09 7.278l.012.01.03.022 5.16 3.867 2.56 1.935 1.554 1.176a1.051 1.051 0 0 0 1.268 0l1.555-1.176 2.56-1.935 5.197-3.89.014-.01A6.297 6.297 0 0 0 24.507 9.5Z" fill="#E24329"></path>
        <path class="tanuki-shape right-cheek" d="m24.507 9.5-.034-.09a11.44 11.44 0 0 0-4.56 2.051l-7.447 5.632 4.742 3.584 5.197-3.89.014-.01A6.297 6.297 0 0 0 24.507 9.5Z" fill="#FC6D26"></path>
        <path class="tanuki-shape chin" d="m7.707 20.677 2.56 1.935 1.555 1.176a1.051 1.051 0 0 0 1.268 0l1.555-1.176 2.56-1.935-4.743-3.584-4.755 3.584Z" fill="#FCA326"></path>
        <path class="tanuki-shape left-cheek" d="M5.01 11.461a11.43 11.43 0 0 0-4.56-2.05L.416 9.5a6.297 6.297 0 0 0 2.09 7.278l.012.01.03.022 5.16 3.867 4.745-3.584-7.444-5.632Z" fill="#FC6D26"></path>
    </svg>
</template>

<style lang="scss" scoped>
@mixin keyframes($animation-name) {
  @keyframes #{$animation-name} {
    @content;
  }
}

@mixin include-keyframes($animation-name) {
  @include webkit-prefix(animation-name, $animation-name);
  @include keyframes($animation-name) {
    @content;
  }
}

@mixin webkit-prefix($property, $value) {
  #{'-webkit-' + $property}: $value;
  #{$property}: $value;
}

@mixin tanuki-logo-colors($path-color) {
  fill: $path-color;
  transition: all 0.8s;

  &:hover {
    fill: lighten($path-color, 25%);
    transition: all 0.1s;
  }
}
.tanuki-logo {
  .tanuki {
    @include tanuki-logo-colors($tanuki-red);
  }

  .left-cheek,
  .right-cheek {
    @include tanuki-logo-colors($tanuki-orange);
  }

  .chin {
    @include tanuki-logo-colors($tanuki-yellow);
  }

  &.animate {
    .tanuki-shape {
      @include webkit-prefix(animation-duration, 1.5s);
      @include webkit-prefix(animation-iteration-count, infinite);
    }

    .tanuki {
      @include include-keyframes(animate-tanuki-base) {
        0%,
        50% {
          fill: $tanuki-red;
        }

        25% {
          fill: lighten($tanuki-red, 25%);
        }
      }
    }

    .right-cheek {
      @include include-keyframes(animate-tanuki-right-cheek) {
        25%,
        75% {
          fill: $tanuki-orange;
        }

        50% {
          fill: lighten($tanuki-orange, 25%);
        }
      }
    }

    .chin {
      @include include-keyframes(animate-tanuki-chin) {
        50%,
        100% {
          fill: $tanuki-yellow;
        }

        75% {
          fill: lighten($tanuki-yellow, 25%);
        }
      }
    }

    .left-cheek {
      @include include-keyframes(animate-tanuki-left-cheek) {
        25%,
        75% {
          fill: $tanuki-orange;
        }

        100% {
          fill: lighten($tanuki-orange, 25%);
        }
      }
    }
  }
}
</style>

<script lang="ts">
import { Component, Prop, Vue } from 'vue-property-decorator'

@Component
export default class App extends Vue {
  @Prop({ default: false })
  loading!: boolean

  @Prop({ default: 25 })
  size!: number

  get width (): number {
    return this.size
  }

  get height (): number {
    return this.size * (24 / 25)
  }

  get logoStyle (): any {
    return { width: `${this.size}px` }
  }
}
</script>
